'$DYNAMIC
' Millennium OS Open Source
' (C) Data Components Software Development - 2005
'
'                             
'     8888888888888888                         
'    000   0008   000                                    oOo
'   OOO   OOOo   OOO                                    8\|/8
'  ooo    oo.   ooo   i  l  l  e  n  n  i  u  m         0-O-0  S
' ;:;          ;:;                                      8/|\8
'                                                        oOo

'This code was originally written by Jonathan Thorpe of Millennium Systems
'To contact us, here are the e-mail addresses:
'      Todd Suess  --  sias.programming@suessweb.com OR tlsuess@suessweb.com
'   Csar Augusto  --  cesarwww@ig.com.br OR cesarwwwsp@bol.com.br
' Jonathan Thorpe  --  jonathanthorp26@hotmail.com

'There are rules to follow for this source code:
' 1. Please DO NOT SELL THIS CODE OR THIS GUI [Modified/Unmodified]
'    (Jonathan wants it to be available for everyone to enjoy)
' 2. If you make modifications to the code, you may use it for private use
' 3. If you would like to make it public, please contact Todd Suess first...
' 4. When using this GUI for public use, please credit us (Todd, Csar, & Jonathan)
' 5. Enjoy this GUI :-)

'Questions (answered by Todd Suess):
'Q: Why are parts of the code taken out?
'A: Think of the reason if Microsoft were to release source code, why they would release the code to Windows 3.x. instead of Windows XP.
'   It is simple. We know that some people do not follow our rules and use the code inappropriately and don't give us credit for it.
'   So, we don't want to release some of the more advanced parts of M-OS.

'Q: Why release the code to M-OS?
'A: Unlike Microsoft, we don't sell M-OS (yet). Why should we restrict code if people are interested?

'If you have any questions, feel free to ask Csar and I... :-)

'PLEASE TELL US HOW YOU LIKE IT OR WHY YOU DON'T LIKE IT
'
'For support, please send an e-mail to: tlsuess@suessweb.com

DEFINT A-Z
DECLARE SUB MultiTasking.Driver (action%, FileOrAction$, MultName$)
DECLARE SUB executeEXEfile (File$)
DECLARE SUB GUItask.Manager (Instruction%, Optin%)
DECLARE SUB BOX (bcol%, x%, y%, x2%, y2%, title$, tc%, tbg%, tsh%, shwmen%, clse%, minm%)
DECLARE SUB ScriptReader (filename$, Switches$)
DECLARE SUB ibox (x%, y%, chrs%, MaxChar%)
DECLARE SUB BuiltInScripts (ScriptName$)
DECLARE SUB HighLightStart (x%, y%, Text$, Extended%)
DECLARE SUB EraseHighLightStart (x%, y%)
DECLARE SUB ShowExtendedStart (SecSTARTx%, SecSTARTy%, filename$)
DECLARE SUB HighLightDesktopMenu (x%, y%, Text$)
DECLARE SUB EraseDesktopMenuHighLight (x%, y%)
DECLARE SUB EraseDesktopMenu (x%, y%)
DECLARE SUB ShowDesktopMenu (x%, y%)
DECLARE FUNCTION MsgBOX% (ok%, cancel%, txt1$, txt2$, title$)
DECLARE SUB CommandAndFileRegistry (comd$)
DECLARE SUB MouseRange (x1%, y1%, x2%, y2%)
DECLARE SUB ChangeIcon ()
DECLARE SUB redraw ()
DECLARE SUB GetIcon ()
DECLARE SUB EraseStart ()
DECLARE SUB MouseHide ()
DECLARE SUB button2 (x1%, y1%, InOut%, txt$, mc%)
DECLARE SUB MouseStatus (lb%, Rb%, xMouse%, yMouse%)
DECLARE FUNCTION MouseLimit% (MiniX%, MiniY%, MaxiX%, MaxiY%)
DECLARE SUB GetClick ()
DECLARE SUB MouseShow ()
DECLARE FUNCTION mouseinit% ()
DECLARE SUB mousedriver (ax%, bx%, cx%, dx%)
DECLARE SUB ShowSTART ()
DECLARE SUB RefreshClock ()
DECLARE SUB DrawDesktop ()
DECLARE SUB Place.Icon (x%, y%, filename$)
DECLARE SUB w (a$, x%, y%, co%, Bkgd%, SHADOW%)
DIM SHARED Taskbar1, TaskBar2, TaskBar3, t1act, t2act, t3act
DIM SHARED Button.Button(650)
DIM SHARED gethighlight(150, 150) AS INTEGER
DIM SHARED OldTime$
DIM SHARED Mouse$
DIM SHARED items%, startx%, starty%, Activated%
DIM SHARED ColorOfBG%
DIM SHARED IcnX%, IcnY%, Icon$, IcnName$, action$, grp%
DIM SHARED MoveX%, MoveY%, MoveIcon$, MoveIconName$, MoveLoad$
DIM SHARED EnableDelete%
DIM SHARED Explorfile$, DefaultExplorFile$, TitleOfWindow$
DIM SHARED text1$
DEF SEG

Explorfile$ = "DESKTOP"
DefaultExplorFile$ = Explorfile$

SCREEN 12
CLOSE #1
OPEN "MULTI.TSK" FOR OUTPUT AS #1
   WRITE #1, "[TASK MANAGEMENT FILE]", ""
CLOSE #1
Mouse$ = SPACE$(57)
FOR I% = 1 TO 57
	READ a$
	H$ = CHR$(VAL("&H" + a$))
	MID$(Mouse$, I%, 1) = H$
NEXT I%
CLOSE #5
 
redraw
MouseShow
MouseRange 0, 0, 640, 480
DO
  RefreshClock
  GetClick
  MouseShow
DO
  
  IF EnableDelete% = 1 AND INKEY$ = CHR$(27) THEN
		EnableDelete% = 0
		redraw
		MouseShow
  END IF
  MouseStatus lb%, Rb%, cx%, dx%


LOOP UNTIL lb% = -1 OR Rb% = -1
IF Explorfile$ <> DefaultExplorFile$ THEN
	  IF MouseLimit(622, 4, 15, 15) = -1 THEN
			DO
				  MouseStatus lb%, Rb%, cx%, dx%
			LOOP WHILE lb% = -1
			
			MultiTasking.Driver 2, Explorfile$, TitleOfWindow$
			Explorfile$ = DefaultExplorFile$
			redraw
	  ELSEIF MouseLimit(607, 4, 15, 15) = -1 THEN
			DO
				  MouseStatus lb%, Rb%, cx%, dx%
			LOOP WHILE lb% = -1
		       
			MultiTasking.Driver 1, Explorfile$, TitleOfWindow$
			Explorfile$ = DefaultExplorFile$
			redraw
	  END IF
END IF
GetIcon
LOOP

NormalMouse:
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

REM $STATIC
SUB BOX (bcol%, x%, y%, x2%, y2%, title$, tc%, tbg%, tsh%, shwmen, clse, minm)
LINE (x%, y%)-(x2%, y2%), bcol%, BF
LINE (x%, y%)-(x2%, y2%), 0, B
LINE (x% + 1, y% + 1)-(x2% - 1, y% + 15), 1, BF
LINE (x% + 1, y% + 15)-(x2% - 1, y% + 15), 0, B
w title$, x% + 3, y% + 2, 15, 0, 0
IF clse THEN
 LINE (x2% - 13, y% + 1)-(x2% - 1, y% + 13), 0, B
 LINE (x2% - 12, y% + 2)-(x2% - 2, y% + 12), 7, BF
 LINE (x2% - 11, y% + 2)-(x2% - 3, y% + 11), 0
 LINE (x2% - 3, y% + 2)-(x2% - 11, y% + 11), 0
END IF

IF minm THEN
 LINE (x2% - 28, y% + 1)-(x2% - 16, y% + 13), 0, B
 LINE (x2% - 27, y% + 2)-(x2% - 17, y% + 12), 7, BF
 
 LINE (x2% - 18, y% + 11)-(x2% - 26, y% + 11), 0
END IF

END SUB

SUB BuiltInScripts (ScriptName$)
   
IF ScriptName$ = "&SHUT_DOWN" THEN
   EraseStart
   
   IF MsgBOX(1, 1, "   Shut Down your Computer?", "", "Shut Down Computer") = 1 THEN
	 MouseHide
	 END
   ELSE
	 MouseHide
	 redraw
	 MouseShow
   END IF
ELSEIF ScriptName$ = "&DESK_REFRESH" THEN
 MouseShow
 MouseHide
 redraw
 MouseShow
ELSEIF ScriptName$ = "&DESK_DELETE" THEN
 EnableDelete% = 1
 redraw
 LINE (0, 1)-(660, 30), 4, BF
 LINE (0, 30)-(660, 32), 0, BF
 w "To Remove an Icon, click on it. To cancel, press ESC on your keyboard.", 30, 10, 15, 0, 0
ELSEIF ScriptName$ = "&DELETE_ICON" THEN
   MouseHide
   IF MsgBOX(1, 1, "  Delete the selected icon?", "", "Confirm Delete") = 1 THEN
	 ELSE
   redraw
	 EXIT SUB
   END IF
	CLOSE
	 OPEN Explorfile$ FOR INPUT AS #1
	 OPEN "tmp_001.tmp" FOR OUTPUT AS #2
   DO
	  INPUT #1, icnxa%, IcnYa%, Icona$, IconName$, IconFile$, groupm%
	  IF IcnX% = icnxa% THEN
		IF IcnY% = IcnYa% THEN
			IF Icon$ = Icona$ THEN
				IF IconName$ = IcnName$ THEN
					IF action$ = IconFile$ THEN
						IF groupm% = grp% THEN
							GOTO skip
						END IF
					END IF
				END IF
			END IF
		END IF
	END IF
   WRITE #2, icnxa%, IcnYa%, Icona$, IconName$, IconFile$, groupm%
skip:
   LOOP UNTIL EOF(1)
   CLOSE
   KILL Explorfile$
   NAME "tmp_001.tmp" AS Explorfile$
EndofSUB:
   OPEN Explorfile$ FOR INPUT AS #3
   redraw

ELSEIF ScriptName$ = "&ABOUT_GUI" THEN
EraseStart
MouseShow
IF MsgBOX(1, 0, "M-OS GUI (c) Data Components", "http://www.datacomponents.tk/", "About") = 1 THEN
END IF
END IF
MouseShow
redraw
END SUB

SUB button2 (x1, y1, InOut, txt$, mc)
x2 = x1 + LEN(txt$) * 8
x2 = x2 + 8
y2 = y1 + 18
LINE (x1, y1)-(x2, y2), 7, BF
LINE (x1, y1)-(x2, y2), 0, B
w txt$, x1 + 4, y1 + 4, 15, 0, 0
END SUB

SUB ChangeIcon

OPEN Explorfile$ FOR INPUT AS #201
OPEN "tmp_001.tmp" FOR OUTPUT AS #202
DO
	INPUT #201, tmpX%, tmpY%, tmpICN$, tmpICNME$, TmpLoad$, tmpgrp%
	IF tmpX% = startx% AND tmpY% = starty% THEN
		tmpX% = MoveX%
		tmpY% = MoveY%
		tmpICN$ = MoveIcon$
		tmpICNME$ = MoveIconName$
	END IF
	WRITE #202, tmpX%, tmpY%, tmpICN$, tmpICNME$, TmpLoad$, tmpgrp%
LOOP UNTIL EOF(201)
CLOSE #201, 202
CLOSE
KILL Explorfile$
NAME "tmp_001.tmp" AS Explorfile$
END SUB

SUB CommandAndFileRegistry (comd$)
comd$ = UCASE$(comd$)
IF ".EXE" = RIGHT$(comd$, 4) THEN
 MouseHide
  executeEXEfile comd$
  redraw
ELSEIF "&" = LEFT$(comd$, 1) THEN
   BuiltInScripts comd$
ELSEIF ".ESM" = RIGHT$(comd$, 4) THEN
   ShowExtendedStart 150, 350, comd$
ELSEIF ".COM" = RIGHT$(comd$, 4) THEN
  MouseHide
  SCREEN 0
  SHELL comd$
  SCREEN 12
  redraw
ELSEIF ".EXP" = RIGHT$(comd$, 4) THEN
  Explorfile$ = UCASE$(comd$)
  DrawDesktop
  redraw
END IF
MouseRange 0, 0, 640, 480

END SUB

SUB DrawDesktop
CALL MouseHide
Tcolor = 15
CLOSE #1
OPEN Explorfile$ FOR INPUT AS #1
DO UNTIL EOF(1)
	INPUT #1, IcnX%, IcnY%, Icon$, IcnName$, action$, grp%
	IF Icon$ = "[MOS-GUI]" THEN
	  TitleOfWindow$ = IcnName$
	  EXIT DO
	END IF
LOOP
CLOSE #1
IF UCASE$(Explorfile$) <> UCASE$(DefaultExplorFile$) THEN
	BOX 15, 0, 0, 640, 453, TitleOfWindow$ + " - Millennium OS Explorer", 15, 0, 0, 0, 1, 1
	Tcolor = 0
END IF
IF EnableDelete% = 1 THEN
	LINE (0, 1)-(660, 30), 4, BF
	LINE (0, 30)-(660, 32), 0, BF
	w "To Remove an Icon, click on it. To cancel, press ESC on your keyboard.", 30, 10, 15, 0, 0
END IF

OPEN Explorfile$ FOR INPUT AS #1
DO UNTIL EOF(1)
INPUT #1, IcnX%, IcnY%, Icon$, IcnName$, action$, grp%

IF Icon$ = "[MOS-GUI]" THEN
  TitleOfWindow$ = IcnName$
  GOTO skipdesk
END IF

Place.Icon IcnX%, IcnY%, "ICONS\" + Icon$ + ".GFX"
w IcnName$, IcnX% - ((LEN(IcnName$) / 2) * 8) + 15, IcnY% + 45, Tcolor, 0, 0
skipdesk:
LOOP
CLOSE #1
CALL MouseShow

END SUB

SUB EraseDesktopMenu (x%, y%)
MouseHide
redraw
MouseShow
END SUB

SUB EraseDesktopMenuHighLight (x%, y%)
MouseHide
PUT (x%, y% - 3), gethighlight, PSET
MouseShow
END SUB

SUB EraseHighLightStart (x%, y%)
MouseHide
PUT (x%, y%), gethighlight%, PSET
MouseShow
END SUB

SUB EraseStart
MouseHide
redraw
Place.Icon 1, 455, "system\GF1__.___"
MouseShow
END SUB

SUB executeEXEfile (File$)
CLOSE #5
SHELL "CD >TMP\DIR$.TMP"
CLOSE #5
CLOSE #1
OPEN "TMP\DIR$.TMP" FOR INPUT AS #1
  INPUT #1, mosDIR$
  CHDIR mosDIR$
CLOSE #5

OPEN "CONFIRM" FOR OUTPUT AS #5
PRINT #5, "Welcome to the Next Millennium"
CLOSE #5
OPEN "system\CONFIRM" FOR OUTPUT AS #5
PRINT #5, "Welcome to the new millenium!"
CLOSE #5


dir$ = File$
I = 1: Sppos = 0
DO WHILE I > 0
	I = INSTR(Sppos + 1, dir$, "\")
	IF I > 0 THEN Sppos = I
LOOP

IF Sppos = 0 THEN
	File$ = dir$
ELSE
	File$ = RIGHT$(dir$, LEN(dir$) - Sppos)
	dir$ = LEFT$(dir$, Sppos - 1)
	CHDIR dir$
END IF
	MouseShow
	SHELL File$
       
CHDIR mosDIR$
MouseShow
END SUB

SUB GetClick
   
MouseStatus lb%, Rb%, cx%, dx%


IF MouseLimit(1, 455, 55, 23) = -1 THEN
   IF lb% = -1 THEN
	  DO
		 MouseStatus lb%, Rb%, cx%, dx%
	  LOOP UNTIL lb% <> -1
	 
	  ShowSTART
	  END IF
ELSEIF MouseLimit(555, 458, 23, 23) = -1 THEN
   IF lb% = -1 THEN
	  CommandAndFileRegistry "SNDMIXER.DLS"
   END IF
ELSEIF MouseLimit(Taskbar1, 457, 150, 20) AND t1act = 1 THEN
  MouseHide
  GUItask.Manager 2, Taskbar1
  MouseShow
  DO
	MouseStatus lb%, Rb%, cx%, dx%
  LOOP WHILE lb% = -1
  GUItask.Manager 3, 1
ELSEIF MouseLimit(TaskBar2, 457, 150, 20) AND t2act = 1 THEN
  MouseHide
  GUItask.Manager 2, TaskBar2
  MouseShow
  DO
	MouseStatus lb%, Rb%, cx%, dx%
  LOOP WHILE lb% = -1
  GUItask.Manager 3, 2
ELSEIF MouseLimit(TaskBar3, 457, 150, 20) AND t3act = 1 THEN
  MouseHide
  GUItask.Manager 2, TaskBar3
  MouseShow
  DO
	MouseStatus lb%, Rb%, cx%, dx%
  LOOP WHILE lb% = -1
  GUItask.Manager 3, 3
END IF
END SUB

SUB GetIcon
CLOSE #3
OPEN Explorfile$ FOR INPUT AS #3

DO
	INPUT #3, IcnX%, IcnY%, Icon$, IcnName$, action$, grp%
   oldlocX% = IcnX%: oldLocY% = IcnY%
	CALL MouseStatus(LeftButton%, RightButton%, xMouse%, yMouse%)
	IF mouseOK% = 0 THEN
		 
		 IF MouseLimit(IcnX%, IcnY%, 30, 30) = -1 THEN
			IF RightButton% = -1 THEN
				CALL MouseHide
				startx% = IcnX%: starty% = IcnY%
				IF UCASE$(Explorfile$) = UCASE$(DefaultExplorFile$) THEN
					 LINE (IcnX% - 40, IcnY% - 1)-STEP(110, 60), ColorOfBG%, BF
				ELSE
					LINE (IcnX% - 40, IcnY% - 1)-STEP(110, 60), 15, BF
				END IF
			     
				Place.Icon IcnX%, IcnY%, "ICONS\" + Icon$ + ".GFX"
				IF UCASE$(Explorfile$) = UCASE$(DefaultExplorFile$) THEN
					 w IcnName$, IcnX% - ((LEN(IcnName$) / 2) * 8) + 15, IcnY% + 45, 15, 0, 0
				ELSE
					 w IcnName$, IcnX% - ((LEN(IcnName$) / 2) * 8) + 15, IcnY% + 45, 0, 0, 0
				END IF
				ExtraX1% = xMouse% - IcnX%: ExtraY1% = yMouse% - IcnY%
				CALL MouseShow
			       
				mouseDragging% = 1
				CALL MouseStatus(LeftButton%, RightButton%, xMouse%, yMouse%)
				xMouse1% = xMouse%: yMouse1% = yMouse%
			END IF
			
			MoveIcon$ = Icon$
			MoveIconName$ = IcnName$
			MoveLoad$ = action$
			IF LeftButton% = -1 AND mouseOK% = 0 AND mouseDragging% <> 1 THEN
		       
				IF EnableDelete% = 1 THEN
					EnableDelete% = 0
					CommandAndFileRegistry "&DELETE_ICON"
					EXIT DO
				ELSE
				DO
						CALL MouseStatus(Leftb%, Rb%, cx%, dx%)
						IF MouseLimit(IcnX%, IcnY%, 30, 30) = 0 THEN
							grp% = -1
							EXIT SUB
						END IF
					LOOP UNTIL Leftb% = 0
				CommandAndFileRegistry action$
				EXIT SUB
				END IF
			END IF
		   END IF
		 END IF
	IF mouseDragging% = 1 THEN
	      
		DO
		       
			DO
				CALL MouseStatus(LeftButton%, RightButton%, xMouse%, yMouse%)
			LOOP UNTIL xMouse% <> xMouse1% OR yMouse% <> yMouse1% OR RightButton% = 0
			xMouse1% = xMouse%: yMouse1% = yMouse%
		       
		LOOP UNTIL RightButton% = 0
		mouseDragging% = 0
		MoveX% = xMouse%: MoveY% = yMouse%
		EnableMove% = 0
		ChangeIcon
		redraw
		EXIT DO
	END IF

LOOP UNTIL EOF(3)
CLOSE #3
CALL MouseShow
		
 IF mouseDragging% <> 1 THEN
	 IF RightButton% = -1 THEN
			 ShowDesktopMenu xMouse%, yMouse%
	 END IF
 END IF

END SUB

SUB GUItask.Manager (Instruction%, Optin%)
IF Instruction% = 1 THEN
	t1act = 0
	t2act = 0
	t3act = 0
	Taskbar1 = 60
	TaskBar2 = 60 + 155
	TaskBar3 = 60 + 310
	yMulti% = 60
	CLOSE #6
	   OPEN "MULTI.TSK" FOR INPUT AS #6
	DO
	   INPUT #6, ObjectName$, Execute$
	IF ObjectName$ = "[TASK MANAGEMENT FILE]" THEN GOTO SkipOneItem
	IF t1act = 1 AND t2act = 1 THEN t3act = 1
	IF t1act = 1 AND t2act = 0 THEN t2act = 1
	IF t1act = 0 THEN t1act = 1
	LINE (yMulti%, 457)-(yMulti% + 150, 477), 15, B
	LINE (yMulti% + 1, 477)-(yMulti% + 150, 477), 8, B
	LINE (yMulti%, 478)-(yMulti% + 151, 478), 0, B
	LINE (yMulti% + 150, 457)-(yMulti% + 150, 476), 8, B
	LINE (yMulti% + 151, 457)-(yMulti% + 151, 477), 0, B
	w ObjectName$, yMulti% + 10, 464, 0, 0, 0
	yMulti% = yMulti% + 155
SkipOneItem:
	IF yMulti% > 520 THEN EXIT DO
	LOOP UNTIL EOF(6)
	CLOSE #6
ELSEIF Instruction% = 2 THEN
   yMulti% = Optin%
   LINE (yMulti%, 457)-(yMulti% + 150, 477), 0, B
   LINE (yMulti% + 1, 477)-(yMulti% + 150, 477), 7, B
   LINE (yMulti%, 478)-(yMulti% + 151, 478), 15, B
   LINE (yMulti% + 150, 457)-(yMulti% + 150, 476), 7, B
   LINE (yMulti% + 151, 457)-(yMulti% + 151, 477), 15, B
ELSEIF Instruction% = 3 THEN
	yMulti% = 0
	CLOSE #6
	   OPEN "MULTI.TSK" FOR INPUT AS #6
	DO
	   INPUT #6, ObjectName$, Execute$
	
	IF Optin% = 1 THEN
	   IF Taskbar1 = yMulti% - 95 THEN
		  CommandAndFileRegistry Execute$
		  EXIT DO
	   END IF
	END IF
	IF Optin% = 2 THEN
	   IF TaskBar2 = yMulti% - 95 THEN
		  CommandAndFileRegistry Execute$
		  EXIT DO
	   END IF
	END IF
	IF Optin% = 3 THEN
	   IF TaskBar3 = yMulti% - 95 THEN
		  CommandAndFileRegistry Execute$
		  EXIT DO
	   END IF
	END IF
   
	yMulti% = yMulti% + 155
	LOOP UNTIL EOF(6)

END IF

END SUB

SUB HighLightDesktopMenu (x%, y%, Text$)
MouseHide
GET (x%, y% - 3)-(x% + 117, y% + 7), gethighlight
LINE (x%, y% - 3)-(x% + 117, y% + 7), 8, BF
w Text$, x%, y%, 15, 0, 0
MouseShow
END SUB

SUB HighLightStart (x%, y%, Text$, Extended%)
MouseHide
IF Extended% = 0 THEN
   GET (x%, y% - 6)-(x% + 87, y% + 12), gethighlight
   LINE (x%, y% - 6)-(x% + 87, y% + 12), 8, BF
   w Text$, x%, y%, 15, 0, 0
ELSE
   GET (x%, y% - 6)-(x% + 137, y% + 12), gethighlight
   LINE (x%, y% - 6)-(x% + 137, y% + 12), 8, BF
   w Text$, x%, y%, 15, 0, 0
END IF
MouseShow
END SUB

SUB mousedriver (ax%, bx%, cx%, dx%)

  DEF SEG = VARSEG(Mouse$)
  Mouse% = SADD(Mouse$)
  CALL ABSOLUTE(ax%, bx%, cx%, dx%, Mouse%)

END SUB

SUB MouseHide
 ax% = 2
 mousedriver ax%, 0, 0, 0
END SUB

FUNCTION mouseinit%
  ax% = 0
  mousedriver ax%, 0, 0, 0
  mouseinit% = ax%
END FUNCTION

FUNCTION MouseLimit (MiniX, MiniY, MaxiX, MaxiY)

MouseLimit = 0
CALL MouseStatus(LeftButton, RightButton, xMouse, yMouse)

IF xMouse >= MiniX AND xMouse <= MiniX + MaxiX THEN
	IF yMouse >= MiniY AND yMouse <= MiniY + MaxiY THEN
		MouseLimit = -1
	END IF
END IF

END FUNCTION

SUB MouseRange (x1%, y1%, x2%, y2%)
  ax% = 7
  cx% = x1%
  dx% = x2%
mousedriver ax%, 0, cx%, dx%
  ax% = 8
  cx% = y1%
  dx% = y2%
  mousedriver ax%, 0, cx%, dx%
END SUB

SUB MouseShow
  ax% = 1
  mousedriver ax%, 0, 0, 0
END SUB

SUB MouseStatus (lb%, Rb%, xMouse%, yMouse%)
  ax% = 3
  mousedriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  Rb% = ((bx% AND 2) <> 0)
  xMouse% = cx%
  yMouse% = dx%
END SUB

FUNCTION MsgBOX (ok%, cancel%, txt1$, txt2$, title$)
MouseHide
MSX = 210
MSY = 180
topofmsgbox:
MouseShow
BOX 7, MSX, MSY, MSX + 260, MSY + 129, title$, 15, 0, 1, 1, 0, 0
IF ok% = 1 THEN
	 button2 MSX + 20, MSY + 80, 0, "  OK  ", 0
END IF
IF cancel% = 1 THEN
	 button2 MSX + 140, MSY + 80, 0, "Cancel", 0
END IF
w txt1$, MSX + 10, MSY + 40, 0, 0, 0
w txt2$, MSX + 10, MSY + 50, 0, 0, 0
MouseShow
DO
   DO
	MouseStatus lb%, Rb%, cx%, dx%
	 KeyPressed$ = INKEY$
	 IF UCASE$(KeyPressed$) = "Y" THEN
		MouseHide
	       redraw
		MouseShow
		MsgBOX = 1
		EXIT FUNCTION
	 ELSEIF UCASE$(KeyPressed$) = "N" THEN
		MouseHide
		redraw
		MouseShow
		MsgBOX = 0
		EXIT FUNCTION
	 END IF
   LOOP UNTIL lb% = -1
	 IF MouseLimit(MSX + 20, MSY + 80, 100, 23) = -1 THEN
	 
		IF runz = 0 THEN
		   MsgBOX = 1
			MouseHide
			redraw
			MouseShow
			EXIT FUNCTION
		END IF
	 ELSEIF MouseLimit(MSX + 140, MSY + 80, 100, 23) = -1 THEN
	   IF cancel% = 1 THEN
	       
			 IF runz = 0 THEN
			 MsgBOX = 0
			 MouseHide
			 redraw
			 MouseShow
			 EXIT FUNCTION
			 END IF
		END IF
	END IF
LOOP

END FUNCTION

SUB MultiTasking.Driver (action, FileOrAction$, MultName$)
IF action = 1 THEN
    CLOSE
    OPEN "multi.tsk" FOR INPUT AS #1
    DO
	INPUT #1, OBJNAME$, Execution$
	IF OBJNAME$ = MultName$ AND Execution$ = FileOrAction$ THEN
	    EXIT SUB
	END IF
    LOOP UNTIL EOF(1)
    CLOSE
    OPEN "multi.tsk" FOR APPEND AS #1
    WRITE #1, MultName$, FileOrAction$
    CLOSE
ELSEIF action = 2 THEN
    CLOSE
    OPEN "multi.tsk" FOR INPUT AS #1
    OPEN "tmp\multi.tmp" FOR OUTPUT AS #2
    DO
	INPUT #1, OBJNAME$, Execution$
	IF OBJNAME$ <> MultName$ AND Execution$ <> FileOrAction$ THEN
	    WRITE #2, OBJNAME$, Execution$
	END IF
	LOOP UNTIL EOF(1)
    CLOSE
    OPEN "multi.tsk" FOR OUTPUT AS #1
    OPEN "tmp\multi.tmp" FOR INPUT AS #2
    DO
	INPUT #2, OBJNAME$, Execution$
	WRITE #1, OBJNAME$, Execution$
    LOOP UNTIL EOF(2)
    CLOSE
END IF
END SUB

SUB Place.Icon (x%, y%, filename$)

DEF SEG = VARSEG(Button.Button(0))
    BLOAD filename$, VARPTR(Button.Button(0))
    DEF SEG
PUT (x%, y%), Button.Button, PSET

END SUB

SUB redraw
MouseHide
CLOSE #1
OPEN "SYSTEM\desktop.ini" FOR INPUT AS #1
INPUT #1, did$, ColorOfBG%
CLOSE #1
PAINT (1, 1), ColorOfBG%
IF Explorfile$ = DefaultExplorFile$ THEN
	LINE (0, 0)-(640, 480), ColorOfBG%, BF
END IF
Place.Icon 1, 455, "system\GF1__.___"
LINE (55, 454)-(640, 480), 7, BF
LINE (0, 454)-(640, 480), 15, B
LINE (550, 457)-(550, 477), 8
LINE (550, 457)-(637, 457), 8
LINE (637, 457)-(637, 477), 15
LINE (550, 477)-(637, 477), 15
Place.Icon 555, 458, "system\GF7__.___"
OldTime$ = "0"
RefreshClock
DrawDesktop
GUItask.Manager 1, 0

END SUB

SUB RefreshClock

IF OldTime$ <> LEFT$(TIME$, 5) THEN
   LINE (580, 460)-(630, 470), 7, BF
   w LEFT$(TIME$, 5), 587, 464, 0, 0, 0
   OldTime$ = LEFT$(TIME$, 5)
END IF

END SUB

SUB ShowDesktopMenu (x%, y%)
MouseHide
x2% = 130
CLOSE #1
OPEN "SYSTEM\DESKMENU.DAT" FOR INPUT AS #1
DO
   INPUT #1, lc%, Name$, Instruction$
   DesMENVARy% = DesMENVARy% + 1
LOOP UNTIL EOF(1)
CLOSE #1
y2% = DesMENVARy% * 20

IF y% + y2% > 451 THEN y% = 450 - y2%
IF x% > 502 THEN x% = 502

LINE (x%, y%)-(x% + x2%, y% + y2%), 7, BF
LINE (x% + 1, y% + 1)-(x% + x2% - 1, y% + y2% - 1), 15, B
LINE (x% + 1, y% + y2% - 1)-(x% + x2%, y% + y2% - 1), 8, BF
LINE (x% + 1, y% + y2%)-(x% + x2%, y% + y2%), 0, BF
LINE (x% + x2% - 1, y% + 1)-(x% + x2% - 1, y% + y2% - 1), 8, BF
LINE (x% + 130, y% + 1)-(x% + x2%, y% + y2% - 1), 0, BF

OPEN "SYSTEM\DESKMENU.DAT" FOR INPUT AS #1
DO
   INPUT #1, lc%, Name$, Instruction$
   w Name$, x% + 5, y% + 15 + lc%, 0, 0, 0
LOOP UNTIL EOF(1)
CLOSE #1

MouseShow
TopOfGetDeskMenu:
CLOSE #1
OPEN "SYSTEM\DESKMENU.DAT" FOR INPUT AS #1
DO
   INPUT #1, lc%, Name$, Instruction$
   CALL MouseStatus(lb%, Rb%, cx%, dx%)
   IF lb% = -1 THEN
	   IF cx% < x% OR dx% < y% OR dx% > y2% + y% OR cx% > x2% + x% THEN
		  EraseDesktopMenu x%, y%
		  EXIT SUB
	   END IF
   END IF
IF dx% > y% + 15 + lc% AND dx% < y% + 15 + lc% + 9 AND x% < cx% AND x2% + x% > cx% THEN
HighLightDesktopMenu x% + 5, y% + 15 + lc%, Name$
DO
CALL MouseStatus(lb%, Rb%, cx%, dx%)
IF lb% = -1 THEN
  EraseDesktopMenu x%, y%
  CommandAndFileRegistry Instruction$
  EXIT SUB
END IF
LOOP WHILE dx% > y% + 15 + lc% AND dx% < y% + 15 + lc% + 9 AND x% < cx% AND x2% + x% > cx%
EraseDesktopMenuHighLight x% + 5, y% + 15 + lc%
END IF
LOOP UNTIL EOF(1)
GOTO TopOfGetDeskMenu
EraseDesktopMenu x%, y%
END SUB

SUB ShowExtendedStart (SecSTARTx%, SecSTARTy%, filename$)

CLOSE #1
OPEN filename$ FOR INPUT AS #1
DO
  INPUT #1, ShowXpos%, Name$, LoadFile$, IconFile$, group%
itmz% = itmz% + 1
LOOP UNTIL EOF(1)
CLOSE #1
SecSTARTy% = 435

SecSTARTy% = SecSTARTy% + 80 - itmz% * 23

LINE (SecSTARTx%, SecSTARTy%)-(SecSTARTx% + 200, SecSTARTy% + 455), 7, BF
LINE (SecSTARTx% + 1, SecSTARTy% + 1)-(SecSTARTx% + 200, 455), 15, B
LINE (SecSTARTx% + 200, SecSTARTy% + 1)-(SecSTARTx% + 200, 455), 8, B
LINE (SecSTARTx% + 201, SecSTARTy% + 1)-(SecSTARTx% + 201, 455), 0, B
LINE (SecSTARTx% + 1, 455)-(SecSTARTx% + 200, 455), 8, B
LINE (SecSTARTx% + 1, 456)-(SecSTARTx% + 200, 456), 0, B

CLOSE #1
OPEN filename$ FOR INPUT AS #1

DO
  INPUT #1, StartXpos%, Name$, LoadFile$, IconFile$, group%
	 w Name$, SecSTARTx% + 26, 440 - StartXpos%, 0, 0, 0
	
  LOOP UNTIL EOF(1)
CLOSE #1



TopOfGetExtendedStart:
CLOSE
OPEN filename$ FOR INPUT AS #2
DO
INPUT #2, StartXpos%, Name$, LoadFile$, IconFile$, group%
  CALL MouseStatus(lb%, Rb%, cx%, dx%)
IF lb% = -1 THEN
   IF cx% < SecSTARTx% OR cx% > SecSTART% + 350 OR dx% < SecSTARTy% OR dx% > 455 THEN
   MouseHide
   redraw
   MouseShow
   EXIT SUB
   END IF
END IF

IF dx% > 440 - StartXpos% AND dx% < 440 - StartXpos% + 10 AND cx% > SecSTARTx% + 50 AND cx% < SecSTARTx% + 200 THEN
  HighLightStart 176, SecSTARTx% + 290 - StartXpos%, Name$, 1
DO
 CALL MouseStatus(lb%, Rb%, cx%, dx%)
 IF lb% = -1 THEN
	MouseHide
	redraw
	MouseShow
	CommandAndFileRegistry LoadFile$
	EXIT SUB
 END IF
LOOP WHILE dx% > 440 - StartXpos% AND dx% < 440 - StartXpos% + 10 AND cx% > SecSTARTx% + 50 AND cx% < SecSTARTx% + 200
  EraseHighLightStart 176, SecSTARTx% + 290 - StartXpos% - 6
END IF
LOOP UNTIL EOF(2)
GOTO TopOfGetExtendedStart
END SUB

SUB ShowSTART
items% = 0
LINE (2, 457)-(54, 457), 0, B
LINE (2, 478)-(54, 478), 15, B
LINE (2, 458)-(2, 476), 0, BF
LINE (54, 458)-(54, 477), 15, BF

CLOSE #1
OPEN "SYSTEM\START.DAT" FOR INPUT AS #1
DO
  INPUT #1, ShowXpos%, Name$, LoadFile$, IconFile$, group%
items% = items% + 1
LOOP UNTIL EOF(1)
redraw
LINE (0, 430 - items% / .045)-(150, 455), 8, B
LINE (1, 431 - items% / .045)-(149, 453), 7, BF
LINE (0, 430 - items% / .045)-(149, 430 - items% / .045), 15, B
LINE (0, 430 - items% / .045)-(0, 453), 15, BF
LINE (150, 430 - items% / .045)-(150, 453), 0, BF
LINE (1, 454)-(149, 454), 0
LINE (1, 430)-(149, 430), 0
LINE (1, 431)-(149, 431), 15
CLOSE #1
OPEN "SYSTEM\START.DAT" FOR INPUT AS #1

DO
  INPUT #1, StartXpos%, Name$, LoadFile$, IconFile$, group%
  w Name$, 20, 440 - StartXpos%, 0, 0, 0
LOOP UNTIL EOF(1)
CLOSE #1
MouseShow


TopOfGetStart:
CLOSE
OPEN "SYSTEM\START.DAT" FOR INPUT AS #2

DO
INPUT #2, StartXpos%, Name$, LoadFile$, IconFile$, group%
CALL MouseStatus(lb%, Rb%, cx%, dx%)

IF dx% > 440 - StartXpos% AND dx% < 440 - StartXpos% + 10 AND cx% < 117 THEN
   HighLightStart 20, 440 - StartXpos%, Name$, 0
DO
CALL MouseStatus(lb%, Rb%, cx%, dx%)
IF lb% = -1 THEN
DO
 CALL MouseStatus(lb%, Rb%, cx%, dx%)
LOOP UNTIL lb% <> -1
CommandAndFileRegistry LoadFile$
EXIT SUB
END IF
LOOP WHILE dx% > 440 - StartXpos% AND dx% < 440 - StartXpos% + 10 AND cx% < 117
EraseHighLightStart 20, 440 - StartXpos% - 6
END IF


IF lb% = -1 THEN
 IF dx% < 429 - items% / .045 OR dx% > 455 OR cx% > 150 THEN
	   EraseStart
	   EXIT SUB
   END IF
END IF

LOOP UNTIL EOF(2)
GOTO TopOfGetStart

EraseStart


END SUB

SUB w (a$, x%, y%, co%, Bkgd%, SHADOW%)
IF systemfontengrave = 1 THEN SHADOW% = 15: co% = 0
DEFINT A-Z
extX% = 8: extY% = 8
DEF SEG = &HFFA6
 FOR I% = 1 TO LEN(a$)
    ADDR% = 8 * ASC(MID$(a$, I%)) + 14
    IF Background% THEN
    IF Background% = 256 THEN BG% = false ELSE BG% = Bkgd%
    IF I% = LEN(a$) THEN extX% = false: extY% = false
    LINE (x%, y%)-(x% + 8 + extX%, y% + 8 + extY%), 0, BF
    END IF
    FOR j% = 0 TO 7: mask% = PEEK(ADDR% + j%) * 128
    LINE (x% + 15, y% + j%)-(x%, y% + j%), co%, , mask%
    NEXT
    x% = x% + extX%
    NEXT: DEF SEG
 END SUB

